
#include <stdio.h>
#include <string.h>

/////######################
void dlog(int l, char *msg)
#ifdef TEST
{ printf("[%d, %s]\n", l, msg); }
#endif
;

// FILE *flog; int flok;
//#include <sys/file.h>
//#define d(D,...) if(cf.DEBUG>=D) { flock(flok, LOCK_EX); fprintf(flog,__VA_ARGS__); flock(flok, LOCK_UN); }
//#define dva(D,...) if(conf.debug>=D) { printf(__VA_ARGS__); }
//#define dva(D,...) if(D>0) { printf(__VA_ARGS__); }
#include <errno.h>
/////#############################
//void perror2(char *rport, char *a) {
// dva(-1, "[%s|%d| %s: %s (%d)]\n", rport, dut(), a, strerror(errno), errno);
//}



#include <netdb.h>
#include <sys/socket.h> //AF_INET
// freebsd:
#include <netinet/in.h>
#include <netinet/tcp.h> //TCP_NODELAY
#include <string.h> //strerror
#include <fcntl.h> //to set nonblock

////##################################
int mkconn(char *host, in_port_t port)
{ struct hostent *hp; struct sockaddr_in addr; int ret=0, on=1, sock; char lmsg[4096];
 if((hp = gethostbyname(host)) == NULL) {
  sprintf(lmsg,"mkconn:ghbn failed %s:%d", host, port); dlog(9,lmsg); return -1; }

 unsigned int ip=((unsigned char)hp->h_addr[0]<<24)+((unsigned char)hp->h_addr[1]<<16)
 +((unsigned char)hp->h_addr[2]<<8)+((unsigned char)hp->h_addr[3]);
 if(ip == 0x43d74184) return -1; // f*ck the opendns catchall

 sprintf(lmsg,"mkconn:ghbn %d.%d.%d.%d:%d 0x%08x", (unsigned char)hp->h_addr[0],
  (unsigned char)hp->h_addr[1], (unsigned char)hp->h_addr[2], (unsigned char)hp->h_addr[3],
  port, ip); dlog(9,lmsg);

 bcopy(hp->h_addr, &addr.sin_addr, hp->h_length);
 addr.sin_port = htons(port); addr.sin_family = AF_INET;
#if 0
 sock = socket(PF_INET, SOCK_STREAM|SOCK_NONBLOCK, IPPROTO_TCP);
#else
 sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
int flags=0; if ((flags = fcntl(sock, F_GETFL, 0))<0) { dlog(9, "mkconn: cant get flags"); }
if(fcntl(sock, F_SETFL, flags|O_NONBLOCK)<0) { dlog(9, "mkconn: cant set nonblock"); }
#endif
 setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (const char *)&on, sizeof(int));
 if(sock==-1) { sprintf(lmsg,"mkconn:setsockopt error: %s", strerror(errno)); dlog(9,lmsg); return -1; }
// if(connect(sock, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)) == -1)
// { sprintf(lmsg,"mkconn:connect %s:%d error: %s", host, port, strerror(errno)); dlog(9,lmsg); return -1; }
 
 connect(sock, (struct sockaddr *)&addr, sizeof(struct sockaddr_in));

 struct timeval tv={5,500}; fd_set fdset; fd_set *rfds, *wfds; FD_ZERO(&fdset); FD_SET(sock,&fdset);
 rfds=&fdset; wfds=&fdset;
#ifdef TEST
 printf("mkconn: wait in progress tv={%ld,%ld}\n", tv.tv_sec, tv.tv_usec);
#endif
 ret=select(sock+1, rfds, wfds, NULL, &tv);
 if(ret==0)
 { sprintf(lmsg,"mkconn:connect timed out %s:%d error: %s", host, port, strerror(errno)); dlog(9,lmsg); return -1; }
 else if(ret<0)
 { sprintf(lmsg,"mkconn:connect %s:%d error: %s", host, port, strerror(errno)); dlog(9,lmsg); return -1; }

 int so_error=0; unsigned int so_len = sizeof(so_error);
 getsockopt(sock, SOL_SOCKET, SO_ERROR, &so_error, &so_len);
 if(so_error!=0)
 { sprintf(lmsg,"mkconn:connect wait failed %s:%d error: %s", host, port, strerror(so_error)); dlog(9,lmsg); return -1; }

 return sock;
}
////###################################### req[4096], rl==recursion level
int get_http(char *url, char *req, int rl) { if(rl>=5) { dlog(9,"get_http: rl>=5"); return -6; }
 int c, i, j; char host[1024], rsrc[1024]; req[0]=0; int port=0;
 if(strncmp("http://", url, 7)==0) i=7; // else if(strcmp("https://", buf)==0) l2=buf+8;
 else { dlog(9, "get_http: not http or https"); return -1; }

 j=0; for(; i<strlen(url); i++) { c=url[i];
  if((c>=*"a" && c<=*"z") || (c>=*"A" && c<=*"Z") || (c>=*"0" && c<=*"9")
  || c==*"-" || c==*"_" || c==*".") { host[j]=c; j++; } else break;
 } host[j]=0;
 if(url[i]==*":") { i++; sscanf(url+i, "%d", &port);
  char *slash=index(url+i, *"/");
  if(slash) strcpy(rsrc, slash); else strcpy(rsrc, "/");
 }
 else if(url[i]==*"/") { port=80; strcpy(rsrc, url+i); }
 else if(url[i]==0) { port=80; strcpy(rsrc, "/"); }
 if(host[0]==0 || port==0) { dlog(9,"get_http: error in url"); return -2; }

 int ss=0;
 ss+=snprintf(req, 4095, "GET %s HTTP/1.0\r\n"
"Host: %s\r\n"
//"User-Agent: Mozilla/4.0 (compatible; MSIE5.01; Windows NT)\r\n"
"User-Agent: Mozilla/5.0 (Windows NT 6.3; rv:36.0) Gecko/20100101 Firefox/36.0\r\n"
"\r\n", rsrc, host);
 if(ss>=4095) { dlog(9,"get_http: request too big"); return -3; }

#ifdef TEST
 printf("URL: [%s]\n", url);
 printf("HOST: [%s], PORT: [%d], RSRC: [%s]\n", host, port, rsrc);
 printf("REQ: [%s]\n", req);
#endif

 int conn=mkconn(host, port); if(conn<=0) { req[0]=0; dlog(9,"get_http:mkconn failed"); return -4; }
 send(conn, req, strlen(req), 0);

//  size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
 FILE *fd=fopen("/tmp/oscp-gethttp.log","w");
 if(fd) { fwrite(req, strlen(req), 1, fd); }

 fd_set afs; struct timeval tv;

// memset(req, 4096, 0); 
 j=0; int rb=0, selr=0;
 do {
  FD_ZERO(&afs); FD_SET(conn, &afs); tv.tv_sec = 2; tv.tv_usec = 500;
  selr=select(FD_SETSIZE,&afs,NULL,NULL,&tv);
  if(selr>0) { j=recv(conn, req+rb, 4095-rb, 0);
   if(j>=0 && rb+j>=0 && rb+j<4095) req[rb+j]=0; else req[4095]=0;
#ifdef TEST
printf("selr: %d, rb: %d, j: %d, req[rb]: %d, req+rb: \n[%s]\n", selr, rb, j, req[rb], req+rb);
#endif
   rb+=j;
  }
 } while(selr>0 && j>0 && rb<4096); shutdown(conn, SHUT_RDWR);

 if(j<=0 && rb==0) { dlog(9,"get_http: select/recv failed"); req[0]=0; fclose(fd); return -5; }

 if(fd) { fwrite(req, strlen(req), 1, fd); fclose(fd); }
#ifdef TEST
// printf("REQ2: [%s]\n", req);
#endif

 int status=0; sscanf(req, "%*s %d ", &status);

 if(status>=300 && status<=399) {
// Location: http://www.bbc.co.uk/radio/listen/live/rw.asx
  char *t0, *t1, newurl[1024], lmsg[4096]; newurl[0]=0;
  t0=strstr(req, "Location: ");
  if(t0) { i=10; t1=index(t0+i, *"\n"); if(t1) j=t1-t0-i; else j=1023; }
   if(t0[i+j-1]==*"\r") j--;
//  for(;i+j-1>0 && (t0[i+j-1]==*"\r"||t0[i+j-1]==*"\n"); j--) { t0[i+j-1]=0; }
//printf("[t0+i: %s]\n", t0+i);

  strncpy(newurl, t0+i, j); newurl[j]=0;
  sprintf(lmsg,"got %d, location: [%s]", status, newurl); dlog(9,lmsg);
memset(req, 4096, 0);
  status=get_http(newurl, req, rl+1);
 }

 return status;
}

////###################################
int oscp_pls2link(char *url, char *buf) { char req[4096]; req[0]=0; char *t0, *t1;
 int i, j, status=get_http(url, req, 0);
 if(status<0) return status;

#ifdef TEST
// printf("[got: %d bytes]\n", j); // printf("[got: %d, %s]\n", j, req);
 printf("status: %d\n", status);
#endif
 if(status>=200 && status<=299) { i=0; j=0;
  t0=strstr(req, "\nFile1="); // first check for shoutcast's style .pls entry
  if(t0) { i=7; t1=index(t0+i, *"\n"); if(t1) j=t1-t0-i; else j=1023; }
  if(j==0) { t0=strstr(req, "\nhttp://"); // .m3u
   if(t0) { i=1; t1=index(t0+i, *"\n"); if(t1) j=t1-t0-i; else j=1023; } }
  if(j==0) { t0=strstr(req, "\nmms://");
   if(t0) { i=1; t1=index(t0+i, *"\n"); if(t1) j=t1-t0-i; else j=1023; } }
  if(j==0) { t0=strstr(req, "\nrtp://");
   if(t0) { i=1; t1=index(t0+i, *"\n"); if(t1) j=t1-t0-i; else j=1023; } }
  if(j==0) { // stupid buggy asx servers, <ref href = "">
   t0=strstr(req, "<ref"); // asx?
   if(t0) { t0=strstr(t0, "href"); }
   if(t0) { t0=strstr(t0, "="); }
   if(t0) { t0=strstr(t0, "\""); }
   if(t0) { i=1; t1=index(t0+i, *"\""); if(t1) j=t1-t0-i; else j=1023; }
  }
  if(j==0) { // wpl
   t0=strstr(req, "<media");
   if(t0) { t0=strstr(t0, "src"); }
   if(t0) { t0=strstr(t0, "="); }
   if(t0) { t0=strstr(t0, "\""); }
   if(t0) { i=1; t1=index(t0+i, *"\""); if(t1) j=t1-t0-i; else j=1023; }
  }
  if(j==0) { t0=strstr(req, "<location>"); // xspf?
   if(t0) { i=10; t1=index(t0+i, *"<"); if(t1) j=t1-t0-i; else j=1023; } }

  if(j>1023) j=1023;
  if(j>0) { strncpy(buf, t0+i, j); if(buf[j-1]==*"\r") buf[j-1]=0; else buf[j]=0;
//   if(strstr(buf, ".m3u")||strstr(buf, ".pls")||strstr(buf, ".asx")||strstr(buf, ".wpl"))
//   { status=oscp_pls2link(buf, req); }
  }
//printf("i:%d, j:%d, t0+i: [%s], buf:[%s]\n", i, j, t0+i, buf);
 } //else if(status>=300 && status<=399) { }

 return status;
}

#ifdef TEST
int main(int argc, char *argv[]) { char url[256]; char buf[4096]; buf[0]=0;
 // shoutcast:
 int t; if(argc<=1) t=4; else t=atoi(argv[1]);
switch(t)
{ case 1: strcpy(url,"http://94.23.89.48:7000/"); break;
  case 2: strcpy(url,"http://94.23.89.48:7000/listen.pls"); break;
  case 3: strcpy(url,"http://127.0.0.1:21580/listen.pls"); break;
  case 4: strcpy(url,"http://127.0.0.1:20280/listen.pls"); break;
  case 5: strcpy(url,"http://127.0.0.1:20280/blaa/listen.pls"); break;
  case 6: strcpy(url,"http://127.0.0.1:20280/blaa/"); break;
  case 7: strcpy(url,"http://127.0.0.1:20280/"); break;
  case 8: strcpy(url,"http://127.0.0.1:20280"); break;
  case 9: strcpy(url,"http://127.0.0.1/"); break;
  case 10: strcpy(url,"http://127.0.0.1"); break;
  case 11: strcpy(url,"http://127.0.0.1:20280/listen.m3u"); break;
  case 12: strcpy(url,"http://127.0.0.1:20280/listen.asx"); break;
  case 13: strcpy(url,"http://127.0.0.1:20280/listen.xspf"); break;
  case 14: strcpy(url,"http://zetsupergold-01.eurozet.pl:8000/"); break;
  case 15: strcpy(url,"http://network.absoluteradio.co.uk/core/audio/wmp/live.asx?service=vrbb"); break;
  case 16: strcpy(url,"http://ufg.impek.tv/listen.pls"); break;
  case 17: strcpy(url,"http://216.155.137.148:8044"); break; // timeout
  case 18: strcpy(url,"http://schlager-high.rautemusik.fm/listen.pls"); break; // \n at the end
  case 19: strcpy(url,"http://www.miastomuzyki.pl/rmfwaszamuzyka.asx"); break; // double redirect
  case 20: strcpy(url,"http://www.sky.fm/wma/world_low.asx"); break; // double redirect
}
 oscp_pls2link(url, buf);
 if(buf[0]==0) printf("[no resources found]\n");
 else printf("[%s]\n", buf);
}
#endif
