#include <unistd.h> //usleep
#include <errno.h>
#include <string.h> //strerror
#include <sys/time.h>
#include <dirent.h> //PATH_MAX

#define PM PATH_MAX

#ifdef LAO
#include <ao/ao.h>
//int aodriver=-1; ao_device *aodevice;
extern ao_sample_format sformat;
#else
struct sample_format_s { int bits; int channels; int rate; };
extern struct sample_format_s sformat;
#endif

#if 1
#include "libavutil/samplefmt.h"
#else
enum AVSampleFormat { AV_SAMPLE_FMT_NONE = -1, AV_SAMPLE_FMT_U8, AV_SAMPLE_FMT_S16,
 AV_SAMPLE_FMT_S32, AV_SAMPLE_FMT_FLT, AV_SAMPLE_FMT_DBL, AV_SAMPLE_FMT_U8P, AV_SAMPLE_FMT_S16P,
 AV_SAMPLE_FMT_S32P, AV_SAMPLE_FMT_FLTP, AV_SAMPLE_FMT_DBLP, AV_SAMPLE_FMT_NB };
#endif
extern enum AVSampleFormat sfmt;

void lfdump();
void lf(char *a);
void lf2(char *a, char *b);
void lfd(char *a, int b);
void dlog(int l, char *msg);
void cs(char *a);
extern int parent_ear, parent_said;
void fdreadline(int fd, char *b, int n);
char * get_basename(char *fn);
char * get_bn2(char *fn);
int get_filesize(char *fn);

extern int vis;
/* struct conf_s {
 int conf_ver,debug,quit,paused, lines,cols, lw,lh, lineart, offs, fullpath, vis,
  shuffle, repeat, eias, autoplay, autoalpha, timeremaining_mode, style[13];
 int lastpos; char wd[PM], file[PM], udir[10][PM], favsavepath[PM], mplayer_path[PM];
} conf; */

void adev_setp(int bits, int *chan, int *rate);
int adev_init();
void adev_close();
void adev_end();
int adev_out(void *smpl_buf, int cnt, int ch, int sfmt);

char * get_conf(char *a);
void set_confS(char *a, char *b);
